VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As Currency) As Long
Private Declare Function timeGetTime Lib "winmm.dll" () As Long

Private Ticks_Per_Second As Currency
Private Start_Time As Currency
Private Milliseconds As Long
Private Last_Time As Long

Private Get_Frames_Per_Second As Long
Private Frame_Count As Long

Private Running As Boolean

Private Sub Main()

    With Me

        .ScaleMode = 3
        .AutoRedraw = True
        .BackColor = RGB(0, 0, 0)
        
    End With

    Running = True

    QueryPerformanceFrequency Ticks_Per_Second

    QueryPerformanceCounter Start_Time
    
    Milliseconds = Time
    
    Game_Loop

End Sub

Private Sub Game_Loop()

    Do While Running = True
    
        DoEvents
        
        Lock_Framerate 60
        
        Cls
        
        Caption = Get_FPS
        
        Render
        
        QueryPerformanceCounter Start_Time
        
    Loop

End Sub

Private Function Time() As Long

    Const Max_Value As Long = 2147483647
    
    If timeGetTime < 0 Then
    
        Time = Max_Value + timeGetTime
        
    Else
    
        Time = timeGetTime
        
    End If

End Function

Private Sub Lock_Framerate(Target_FPS As Long)

    Static Last_Time As Currency

    Dim Current_Time As Currency
    
    Dim FPS As Single
    
    Do

        QueryPerformanceCounter Current_Time
    
        FPS = Ticks_Per_Second / (Current_Time - Last_Time)
    
    Loop While (FPS > Target_FPS)
    
    QueryPerformanceCounter Last_Time

End Sub

Private Function Get_FPS() As String

    Frame_Count = Frame_Count + 1
        
    If Time - Milliseconds >= 1000 Then
        
        Get_Frames_Per_Second = Frame_Count

        Frame_Count = 0

        Milliseconds = Time
        
    End If
    
    Get_FPS = "FPS: " & Get_Frames_Per_Second

End Function

Private Sub Clear()

    Me.Cls

End Sub

Private Sub Render()
    
    Dim X As Long, Y As Long
    
    X = Me.ScaleWidth / 2
    Y = Me.ScaleHeight / 2
    
    Line (X + 0, Y + -50)-(X + -50, Y + 50), RGB(0, 255, 0)
    Line (X + 0, Y + -50)-(X + 50, Y + 50), RGB(0, 255, 0)
    Line (X + -50, Y + 50)-(X + 50, Y + 50), RGB(0, 255, 0)

End Sub

Private Sub Close_Program()

    Running = False
    
    Unload Me
    
    End

End Sub

Private Sub Form_Activate()

    Main

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    If KeyCode = vbKeyEscape Then
    
        Close_Program
        
    End If

End Sub
