VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type POINT2D

    X As Single
    Y As Single

End Type

Private Type VECTOR2D

    X As Single
    Y As Single

End Type

Private Type FORCE2D

    Net As VECTOR2D

End Type


Private Type PHYSICS2D
    
    Position As POINT2D
    Velocity As VECTOR2D
    
End Type

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As Currency) As Long
Private Declare Function timeGetTime Lib "winmm.dll" () As Long

Private Ticks_Per_Second As Currency
Private Start_Time As Currency
Private Milliseconds As Currency

Private Get_Frames_Per_Second As Long
Private Frame_Count As Long

Private Running As Boolean

Private Time As Single
'Private Initial_Time As Single
'Private Current_Time As Currency
'Private Last_Time As Currency
Private Delta_Time As Currency
Private Accumulator As Single
Private Obj As PHYSICS2D
Private Time_Step As Single

Private Sub Main()

    With Me

        .ScaleMode = 3
        .AutoRedraw = True
        .BackColor = RGB(0, 0, 0)
        
    End With
    
    With Obj
    
        .Position.X = Me.ScaleWidth / 2
        .Position.Y = Me.ScaleHeight / 2
        .Velocity.X = 50
        .Velocity.Y = 0
    
    End With

    Time_Step = 1 / 1000

    Running = True

    QueryPerformanceFrequency Ticks_Per_Second
    
    Milliseconds = Time
    
    Game_Loop

End Sub

Private Sub Game_Loop()

    Do While Running = True
    
        DoEvents
        
        Lock_Framerate 60
        
        Cls
        
        Delta_Time = Get_Elapsed_Time_Per_Frame
        
        If Delta_Time > 0.25 Then Delta_Time = 0.25
        
        Accumulator = Accumulator + Delta_Time
        
        While (Accumulator >= Time_Step)
        
            'DoEvents
            
            Accumulator = Accumulator - Time_Step
             
            Integrate2D Obj, Time_Step
            
            Time = Time + Time_Step
            
        Wend
        
        Render

    Loop

End Sub

Private Sub Lock_Framerate(Target_FPS As Long)

    Static Last_Time As Currency

    Dim Current_Time As Currency
    
    Dim FPS As Single
    
    Do

        QueryPerformanceCounter Current_Time
    
        FPS = Ticks_Per_Second / (Current_Time - Last_Time)
    
    Loop While (FPS > Target_FPS)
    
    QueryPerformanceCounter Last_Time

End Sub

Private Function Get_Elapsed_Time_Per_Frame() As Single

    Static Last_Time As Currency

    Static Current_Time As Currency

    QueryPerformanceCounter Current_Time
    
    Get_Elapsed_Time_Per_Frame = (Current_Time - Last_Time) / Ticks_Per_Second
    
    QueryPerformanceCounter Last_Time

End Function

Private Function Get_Elapsed_Seconds() As Single
    
    Dim Last_Time As Currency
    
    Dim Current_Time As Currency

    QueryPerformanceCounter Current_Time
    
    Get_Elapsed_Seconds = (Current_Time - Last_Time) / Ticks_Per_Second
    
    QueryPerformanceCounter Last_Time
    
End Function

Private Function Get_FPS(Optional ByVal Elapsed_Frames As Long = 1) As Long

    Static Last_Time As Currency

    Dim Current_Time As Currency
    
    QueryPerformanceCounter Current_Time
    
    Get_FPS = Int(Elapsed_Frames * Ticks_Per_Second / (Current_Time - Last_Time))
    
    QueryPerformanceCounter Last_Time
    
End Function

Private Sub Integrate2D(Obj As PHYSICS2D, dt As Single)
    
    With Obj
        
        .Position.X = .Position.X + .Velocity.X * dt
        .Position.Y = .Position.Y + .Velocity.Y * dt
                
    End With

End Sub

Private Sub Clear()

    Me.Cls

End Sub

Private Sub Render()
    
    Dim X As Long, Y As Long
    
    X = Obj.Position.X
    Y = Obj.Position.Y
    
    Line (X + 0, Y + -15)-(X + -15, Y + 15), RGB(0, 255, 0)
    Line (X + 0, Y + -15)-(X + 15, Y + 15), RGB(0, 255, 0)
    Line (X + -15, Y + 15)-(X + 15, Y + 15), RGB(0, 255, 0)

End Sub

Private Sub Close_Program()

    Running = False
    
    Unload Me
    
    End

End Sub

Private Sub Form_Activate()

    Main

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    If KeyCode = vbKeyEscape Then
    
        Close_Program
        
    End If

End Sub
